#!/usr/bin/perl
#
# Pu-roxy
#
# Copyright (c) 2004 Satoshi Fukutomi <fuktommy@inter7.jp>
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. Neither the name of the University nor the names of its contributors
#    may be used to endorse or promote products derived from this software
#    without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: pu.cgi,v 1.2 2004/08/13 13:40:10 fuktommy Exp $
#

use Pu::Config;
use Pu::Document;
use Pu::System;
use Pu::Post;
use CGI;

$ENV{LANG}="C";
open STDERR, "> /dev/null" if (-w "/dev/null");

# ǰΤPOSTΤȤƤФƤ
if ($ENV{REQUEST_METHOD} eq "POST") {
	read(STDIN,$content_post,$ENV{CONTENT_LENGTH});
}

# ɤURL򻲾ȤΤޤåιϤΤ
$cgi = new CGI();
$mode = $cgi->url_param('mode');
$url = $cgi->url_param('url');
$key = $cgi->url_param('key');
$off = $cgi->url_param('off');
$pu = $cgi->script_name();
$url = $ENV{QUERY_STRING} if (($mode eq "")&&($url eq ""));

# ԤϽ񤭹ʤ
# åȤʤ
if ((($mode =~ /post/)||($mode eq "cache")||($mode eq "tcache"))
	&& ($cgi->remote_host() !~ /$Pu::Config::arrowHost/)) {
	Pu::Document::cm();
	exit;

} elsif ($url =~ m{^/|\.\.}) {
	Pu::Document::cm();
	exit;
}

# ɬפʤflock
mkdir $Pu::Config::cacheDir, 0700 unless (-d $Pu::Config::cacheDir);
umask $Pu::Config::umask;
if ($Pu::Config::lockMode) {
	open LOCK, "> " . $Pu::Config::cacheDir . "/lock";
	unless (flock LOCK, $Pu::Config::lockMode) {
		Pu::Document::cm();
		exit;
	}
}

# ̤ʥ⡼ɤư
if ($mode eq "cm") {			# 
	Pu::Document::cm();
	exit;
} elsif ($mode eq "menu") {		# ˥塼
	Pu::System::get($Pu::Config::menuURL);
	Pu::System::printMenu($Pu::Config::menuURL);
	exit;
} elsif ($mode eq "cache") {		# å(ե̾ǥ)
	Pu::System::cache(sort=>"file");
	exit;
} elsif ($mode eq "tcache") {		# å(ǥ)
	Pu::System::cache(sort=>"stamp");
	exit;
} elsif ($mode eq "post") {		# 񤭹߽
	Pu::Post::postWindow($url);
	exit;
} elsif ($mode eq "realpost") {		# 񤭹
	Pu::Post::makeDataAndPost($url, $content_post);
	exit;
} elsif ($mode eq "remove") {		# 
	Pu::System::remove($url);
	exit;
} elsif ($mode eq "search") {		# 
	Pu::System::search($key, $off);
	exit;
}

# URL줾ФƤư
if ($url eq "") {			# ˥塼
	Pu::System::get($Pu::Config::menuURL);
	Pu::System::printMenu($Pu::Config::menuURL);
	exit;
} elsif ($url =~ m|^[^/]+/[^/]+/$|) {	# 
	Pu::System::get("$url/subject.txt");
	Pu::System::printSubject("$url/subject.txt");
	exit;
} elsif ($url =~ m|\.dat$|) {		# 
	if ($mode eq "update") {
		Pu::System::update($url);
	} else {
		Pu::System::sync($url);
	}
	Pu::System::printDat($url);
	exit;
} elsif ($url =~ m|read\.cgi|) {	# 
	$url =~ s|http://||;
	$url =~ s|test/read.cgi/||;
	$url =~ s|/[^/]*$||;
	$url =~ s|\d+$|dat/$&.dat|;
	if ($mode eq "update") {
		Pu::System::update($url);
	} else {
		Pu::System::sync($url);
	}
	Pu::System::printDat($url);
	exit;
} else {				# ƥ
	Pu::Document::printHeader("");
	print "<BODY><P><A href='$url'>$url</A><P></BODY></HTML>\n";
	exit;
}

Pu::Document::cm();
exit;
